#!/usr/bin/env python -------------------------------- -*- coding: utf-8 -*-#
#                      2023 3DMish <Mish7913@gmail.com>                     #

# -----              ##### BEGIN GPL LICENSE BLOCK #####              ----- #
#                                                                           #
#  This  program  is  free  software;   you  can  redistribute  it  and/or  #
#  modify  it  under  the  terms  of   the   GNU  General  Public  License  #
#  as  published  by  the  Free  Software  Foundation;  either  version  2  #
#  of the License, or (at your option) any later version.                   #
#                                                                           #
#  This program  is  distributed  in the hope  that  it  will  be  useful,  #
#  but  WITHOUT  ANY  WARRANTY;  without  even  the  implied  warranty  of  #
#  MERCHANTABILITY  or  FITNESS   FOR  A  PARTICULAR  PURPOSE.    See  the  #
#  GNU General Public License for more details.                             #
#                                                                           #
#  You  should  have  received  a  copy  of the GNU General Public License  #
#  along with this program; if not, write to the Free Software Foundation,  #
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       #
#                                                                           #
# -----               ##### END GPL LICENSE BLOCK #####               ----- #

import os, sys;

sys.path.insert(0, os.path.dirname(os.path.abspath(__file__)) + "/");

from bpy.types import Panel;

from bpy_sys import (
    q_register_class, q_unregister_class, r_register_class, r_unregister_class,
    ObjectPropsPanel, get_prop, lc_cont_x,
);

bl_conf = {
    "OBJECT_PT_context_object": None,
}

class OBJECT_PT_context_object (ObjectPropsPanel, Panel):
    bl_label = "";
    bl_options = {'HIDE_HEADER'};

    def draw(self, context):
        lc_main = self.layout;
        lc_space = context.space_data;

        lc_row = lc_main.row(align = True);
        if lc_space.use_pin_id: lc_row.template_ID(lc_space, "pin_id");
        else: lc_row.template_ID(context.view_layer.objects, "active", filter='AVAILABLE');
        lc_cont_x(lc_row, 0.6).prop(context.active_object, "display_type", text="", icon="VIS_SEL_10");
            

def register_nodes (self, context):
    if (get_prop("object_props_panel")): register();
    else: unregister();

classes = [
    OBJECT_PT_context_object
];

def register():
    global bl_conf;
    
    r_unregister_class(bl_conf, "OBJECT_PT_context_object");
    
    q_register_class(classes);
    
def unregister():
    global bl_conf;
    
    q_unregister_class(classes);
    
    r_register_class(bl_conf, "OBJECT_PT_context_object");
