#!/usr/bin/env python -------------------------------- -*- coding: utf-8 -*-#
#                      2023 3DMish <Mish7913@gmail.com>                     #

# -----              ##### BEGIN GPL LICENSE BLOCK #####              ----- #
#                                                                           #
#  This  program  is  free  software;   you  can  redistribute  it  and/or  #
#  modify  it  under  the  terms  of   the   GNU  General  Public  License  #
#  as  published  by  the  Free  Software  Foundation;  either  version  2  #
#  of the License, or (at your option) any later version.                   #
#                                                                           #
#  This program  is  distributed  in the hope  that  it  will  be  useful,  #
#  but  WITHOUT  ANY  WARRANTY;  without  even  the  implied  warranty  of  #
#  MERCHANTABILITY  or  FITNESS   FOR  A  PARTICULAR  PURPOSE.    See  the  #
#  GNU General Public License for more details.                             #
#                                                                           #
#  You  should  have  received  a  copy  of the GNU General Public License  #
#  along with this program; if not, write to the Free Software Foundation,  #
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       #
#                                                                           #
# -----               ##### END GPL LICENSE BLOCK #####               ----- #

m7a_meshes = {
    "humans": {
        "male": {
            "base_forms": [
                ("id", 0),
                (0, "M7A-7913-MESH-3845229", "R: Man 30-40yo", "Realistic man about 30-40yo"),
                (2, "M7A-7913-MESH-3487521", "R: Strong Man",  "Realistic strong man about 40-50yo"),
                (4, "M7A-7913-MESH-3215221", "C: Boy 13-15yo", "Cartoon boy about 13-15yo"),
            ],
            "heads": [
                
            ],
            "teeth": [
                ("id", 2),
                (0, "M7A-7913-MESH-3213565", "R: Teeth", "Realistic humans teeth"),
            ],
            "eyes": [
            
            ],
            "noses": [
                ("id", 4),
                (0, "M7A-7913-MESH-4832156", "R: Nose", "Realistic nose"),
            ],
            "lips": [
                ("id", 5),
                (0, "M7A-7913-MESH-1310229", "R: Lips 1", "Realistic male lips"),
                (1, "M7A-7913-MESH-1213551", "R: Lips 2", "Realistic male lips"),
                (20, "M7A-7913-MESH-1258465", "C: Lips 1", "Cartoon lips"),
            ],
            "ears": [
                ("id", 6),
                (0, "M7A-7913-MESH-5135462", "R: Ear", "Realistic ear"),
            ],
            "hands": [
                ("id", 7),
                (0, "M7A-7913-MESH-4821455", "R: Hand", "Realistic hand"),
            ],
            "feet": [
            
            ],
        },
        "female": {
            "base_forms": [
                ("id", 0),
                (1, "M7A-7913-MESH-4851322", "R: Girl 12-16yo",  "Realistic girl about 12-16yo"),
                (0, "M7A-7913-MESH-4851324", "R: Girl 18-25yo",  "Realistic girl about 18-25yo"),
                (2, "M7A-7913-MESH-4851326", "R: Fat Girl 35yo", "Realistic fat girl about 30-40yo"),
                (4, "M7A-7913-MESH-4851323", "C: Princess 10yo", "Cartoon princess in Disney style about ~10yo"),
                (5, "M7A-7913-MESH-4851325", "C: Princess 20yo", "Cartoon princess in Disney style about ~20yo"),
                (6, "M7A-7913-MESH-4851311", "C: Girl Chibi",    "Cartoon Chibi Girl"),
            ],
            "heads": [
                ("id", 1),
                (0, "M7A-7913-MESH-1116584", "R: Head 12-16yo",  "Realistic girl's head about 12-16yo"),
                (1, "M7A-7913-MESH-1116585", "R: Head 18-25yo",  "Realistic girl's head about 18-25yo"),
            ],
            "teeth": [
                ("id", 2),
                (0, "M7A-7913-MESH-3213565", "R: Teeth", "Realistic humans teeth"),
            ],
            "eyes": [
                
            ],
            "noses": [
                ("id", 4),
                (0, "M7A-7913-MESH-4832156", "R: Nose", "Realistic nose"),
            ],
            "lips": [
                ("id", 5),
                (0, "M7A-7913-MESH-4852145", "R: Lips 1", "Realistic female lips"),
                (1, "M7A-7913-MESH-4857661", "R: Lips 2", "Realistic female lips"),
                (10, "M7A-7913-MESH-4857659", "C: Lips 1", "Cartoon female lips"),
                (11, "M7A-7913-MESH-4857660", "C: Lips 2", "Cartoon female lips"),
                (20, "M7A-7913-MESH-1258465", "C: Lips 3", "Cartoon lips"),
            ],
            "ears": [
                ("id", 6),
                (0, "M7A-7913-MESH-5135462", "R: Ear", "Realistic ear"),
            ],
            "hands": [
                ("id", 7),
                (0, "M7A-7913-MESH-4821455", "R: Hand", "Realistic hand"),
            
            ],
            "feet": [
            
            ],
        },
    },
    
    "a_birds": {
        "chicken": {
            "male": {
                "base_forms": [
                    ("id", 0),
                    (0, "M7A-7913-MESH-4476549", "R: Rooster", "Realistic: Rooster Base Form"),
                ],
            },
            "female": {
                "base_forms": [
                    ("id", 0),
                    (0, "M7A-7913-MESH-4476548", "R: Chicken", "Realistic: Chicken Base Form"),
                ],
            },
        },
    },
    
    "a_cattles": {
        
    },
    
    "a_beasts": {
        
    },
    
    "a_rodent": {
        
    },
    
    "a_reptiles": {
        
    },
    
    "a_arthropod": {
        
    },
    
    "clothes": {
        "mesh": {
            "button": [
                ("id", 0),
                (0, "M7A-7913-MESH-5872254", "Button 2 Holes", "Button 2 Holes Mesh"),
                (1, "M7A-7913-MESH-5872255", "Button 4 Holes", "Button 4 Holes Mesh"),
            ],
            "other": [
            ],
        },
        "script": {
            "seam": [
                ("id", 1),
                (0, "M7A-7913-SCRIPT-8755933", "E: Simple Seam", "Generate seam from selected edge"),
                #(1, "M7A-7913-SCRIPT-8755934", "E: Jeans Seam",  "Generate jeans seam from selected edge"),
            ],
            "stitch": [
            ],
        }
    },
    
    "simple": {
        "geometric": [
            ("id", 0),
            (0, "M7A-7913-MESH-0215052", "Hexahedron",        "Hexahedron (Cube) Mesh"),
            (1, "M7A-7913-MESH-0218452", "Dodecahedron",      "Dodecahedron Mesh"),
            (2, "M7A-7913-MESH-0225452", "Icosahedron",       "Icosahedron Mesh"),
            (3, "M7A-7913-MESH-0225448", "Icosidodecahedron", "Icosidodecahedron Mesh"),
            (4, "M7A-7913-MESH-0225492", "Octahedron",        "Octahedron Mesh"),
            (5, "M7A-7913-MESH-0225495", "Tetrahedron",       "Tetrahedron Mesh"),
            (6, "M7A-7913-MESH-0225498", "Pyramid",           "Pyramid Mesh"),
        ],
    },
    
    "scripts": {
        "all": [
            ("id", 0),
            (0, "M7A-7913-SCRIPT-8755933", "E: Simple Seam", "Generate seam from selected edge"),
        ],
    },
    
    "other": {
        
    },
};
