#!/usr/bin/env python -------------------------------- -*- coding: utf-8 -*-#
#                      2023 3DMish <Mish7913@gmail.com>                     #

# -----              ##### BEGIN GPL LICENSE BLOCK #####              ----- #
#                                                                           #
#  This  program  is  free  software;   you  can  redistribute  it  and/or  #
#  modify  it  under  the  terms  of   the   GNU  General  Public  License  #
#  as  published  by  the  Free  Software  Foundation;  either  version  2  #
#  of the License, or (at your option) any later version.                   #
#                                                                           #
#  This program  is  distributed  in the hope  that  it  will  be  useful,  #
#  but  WITHOUT  ANY  WARRANTY;  without  even  the  implied  warranty  of  #
#  MERCHANTABILITY  or  FITNESS   FOR  A  PARTICULAR  PURPOSE.    See  the  #
#  GNU General Public License for more details.                             #
#                                                                           #
#  You  should  have  received  a  copy  of the GNU General Public License  #
#  along with this program; if not, write to the Free Software Foundation,  #
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       #
#                                                                           #
# -----               ##### END GPL LICENSE BLOCK #####               ----- #

import os, sys;

sys.path.insert(0, os.path.dirname(os.path.abspath(__file__)) + "/");
sys.path.insert(0, os.path.dirname(os.path.abspath(__file__)) + "/../");

from bpy_sys import (
    q_register_class, q_unregister_class, 
    lc_switcher, lc_add_btn,
);

def draw_panel (lc_main, context):
    a_obj = context.active_object;
    
    if (a_obj.type == "SPEAKER"):
        if (context.mode in {"OBJECT"}): # -----------------------------------------------
            lc_switcher(lc_main, context, "Speaker", icon="OUTLINER_DATA_SPEAKER", convert=False);
            
            lc_main.separator();
    
    elif (a_obj.type == "SURFACE"):
        if (context.mode in {"OBJECT"}): # -----------------------------------------------
            lc_swtch_row = lc_switcher(lc_main, context, "Surface", icon="SURFACE_DATA");
            lc_add_btn(lc_swtch_row, "object.mode_set", "", "EDITMODE_HLT", 'EDIT', False);
            
            lc_main.separator();
            
            lc_main.prop(a_obj, "resolution_u", text="Viewport");
            lc_main.prop(a_obj, "resolution_v", text="Viewport");
            
            lc_main.separator();
            
            lc_main.prop(a_obj, "render_resolution_u", text="Render");
            lc_main.prop(a_obj, "render_resolution_v", text="Render");

classes = [
    
];

def register():
    q_register_class(classes);
    
def unregister():
    q_unregister_class(classes);
